"use strict";
var registry_1 = require("./registry/registry");
var resolver_1 = require("./resolver/resolver");
var scope_1 = require("./scope");
var Container = (function () {
    function Container() {
        this.registry = new registry_1.default();
        this.resolver = new resolver_1.default();
    }
    Container.create = function () {
        return new Container();
    };
    Container.prototype.register = function (key, provider) {
        this.registry.register(key, provider, scope_1.default.Prototype);
        return this;
    };
    Container.prototype.registerSingleton = function (key, provider) {
        this.registry.register(key, provider, scope_1.default.Singleton);
        return this;
    };
    Container.prototype.get = function (key) {
        return this.resolver.resolve(this, this.registry, key);
    };
    return Container;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Container;
//# sourceMappingURL=container.js.map