"use strict";
var Registry = (function () {
    function Registry() {
        this.registrations = new Map();
        this.instances = new Map();
    }
    Registry.prototype.register = function (key, provider, scope) {
        var registration = { key: key, provider: provider, scope: scope };
        this.registrations.set(key, registration);
        return registration;
    };
    Registry.prototype.registerInstance = function (key, instance) {
        this.instances.set(key, instance);
    };
    Registry.prototype.get = function (key) {
        return this.registrations.get(key);
    };
    Registry.prototype.getInstance = function (key) {
        return this.instances.get(key);
    };
    return Registry;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Registry;
//# sourceMappingURL=registry.js.map