"use strict";
var errors_1 = require("../errors");
var Path = (function () {
    function Path() {
        this.data = [];
    }
    Path.prototype.push = function (key) {
        if (this.has(key)) {
            throw errors_1.circularDependencyError(this.toArray());
        }
        this.data.push(key);
    };
    Path.prototype.pop = function () {
        this.data.pop();
    };
    Path.prototype.has = function (key) {
        return this.data.indexOf(key) >= 0;
    };
    Path.prototype.toArray = function () {
        return this.data.slice();
    };
    return Path;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Path;
//# sourceMappingURL=path.js.map