"use strict";
var errors_1 = require("../errors");
var Resolve = (function () {
    function Resolve(container, registry, path) {
        this.container = container;
        this.registry = registry;
        this.path = path;
    }
    Resolve.prototype.execute = function (key) {
        var registration = this.registry.get(key);
        if (!registration) {
            throw errors_1.notFoundError(key);
        }
        try {
            this.path.push(key);
            return registration.provider(this.container);
        }
        finally {
            this.path.pop();
        }
    };
    return Resolve;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Resolve;
//# sourceMappingURL=resolve.js.map