"use strict";
var path_1 = require("./path");
var resolve_1 = require("./resolve");
var resolve_singleton_1 = require("./resolve-singleton");
var scope_1 = require("../scope");
var Resolver = (function () {
    function Resolver() {
        this.path = new path_1.default();
    }
    Resolver.prototype.resolve = function (container, registry, key) {
        var registration = registry.get(key);
        var strategy;
        if (registration && registration.scope === scope_1.default.Singleton) {
            strategy = new resolve_singleton_1.default(container, registry, this.path);
        }
        else {
            strategy = new resolve_1.default(container, registry, this.path);
        }
        return strategy.execute(key);
    };
    return Resolver;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Resolver;
//# sourceMappingURL=resolver.js.map